Program ZED;

{.$define tweak    - 360x240 }
{.$define hidden   - remove back faces }
{.$define sort     - sort faces (nearest first for ZBuffer test) }
{.$define fullface - one color per face }


{
 Sample Z-Buffer 3D Program

  TothPaul@mygale.org
  http://www.mygale.org/~tothpaul

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

}

uses
 {$ifdef tweak}tweak{$else}modey{$endif},Torus,Trigo;

Var
 Pal:array[0..255,0..2] of byte;
 i:word;
 z1,z2:integer;

Const
 fac=2;
Var
 BaseShade:word;

function keypressed:boolean; assembler;
 asm
  mov es,Seg0040
  mov ax,es:[$1A]
  sub ax,es:[$1C]
  or  al,ah
 end;

procedure QuickSort(left,right:word);
 var
  i,j:word;
  x,y:longint;
 begin
  i:=left;
  j:=right;
  x:=deltaz^[(left+right+1)shr 1];
  repeat
   while (deltaz^[i]>x) do inc(i);
   while (x>deltaz^[j]) do dec(j);
   if (i<=j) then begin
    y:=deltaz^[i]; deltaz^[i]:=deltaz^[j]; deltaz^[j]:=y;
    y:=facelist^[i]; facelist^[i]:=facelist^[j]; facelist^[j]:=y;
    inc(i);
    dec(j);
   end;
  until i>j;
  if (left<j) then quicksort(left,j);
  if (i<right) then quicksort(i,right);
 end;

function Shade(const vector:TVector):integer;
 begin
  Shade:=BASESHADE+ABS((Light.x*Vector.x)+(Light.y*Vector.y)+(Light.z*Vector.z*3 div 4));
 end;

procedure DrawWorld;
 var
  i:word;
 begin

  rotate(Coords,Coords,VerticeCount);
  project(Coords,VerticeCount);
  rotate(@VNormals,TempNorm,VerticeCount);
 {$ifdef hidden}
  rotate(@FNormals,TempNorm2,FaceCount);
 {$else}
  {$ifdef fullface}
   rotate(@FNormals,TempNorm2,FaceCount);
  {$endif}
 {$endif}

 {$ifdef sort}

  for i:=0 to FaceCount-1 do begin
   FaceList^[i]:=i;
   with Faces[i] do
    deltaZ^[i]:=longint(Coords^[a].z+Coords^[b].z+Coords^[c].z) div 3;
  end;

  QuickSort(0,FaceCount-1);

  for i:=FaceCount-1 downto 0 {to FaceCount-1} do
   with Faces[FaceList^[i]] do
  {$ifdef hidden}if (TempNorm2^[FaceList^[i]].z>=0) then{$endif}

 {$else}

  for i:=0 to FaceCount-1 do
   with Faces[i] do
   {$ifdef hidden}if (TempNorm2^[i].z>0) then{$endif}

 {$endif}

  begin
  {$ifdef fullface}
   InitZPoly(Coords^[a].x,Coords^[a].y,Coords^[a].z);
   ScanZPoly(Coords^[b].x,Coords^[b].y,Coords^[b].z);
   ScanZPoly(Coords^[c].x,Coords^[c].y,Coords^[c].z);
   ScanZPoly(Coords^[a].x,Coords^[a].y,Coords^[a].z);
   DrawZPoly(shade(TempNorm2^[{$ifdef sort}FaceList^[i]{$else}i{$endif}]));
  {$else}
   InitZGouraud(Coords^[a].x,Coords^[a].y,Coords^[a].z,Shade(TempNorm^[a]));
   ScanZGouraud(Coords^[b].x,Coords^[b].y,Coords^[b].z,Shade(TempNorm^[b]));
   ScanZGouraud(Coords^[c].x,Coords^[c].y,Coords^[c].z,Shade(TempNorm^[c]));
   ScanZGouraud(Coords^[a].x,Coords^[a].y,Coords^[a].z,Shade(TempNorm^[a]));
   DrawZGouraud;
  {$endif}
  end;

 end;

begin
 GraphMode;

 for i:=1 to 127 Do begin
  pal[i,0]:=i div fac;
  pal[i,1]:=10+Round(i/fac/1.4);
  pal[i,2]:=20+Round(i/fac/1.6);
 end;
 for i:=1 to 127 Do begin
  pal[127+i,0]:=i div fac;
  pal[127+i,2]:=10+Round(i/fac/1.4);
  pal[127+i,1]:=20+Round(i/fac/1.6);
 end;

 SetPalette(@Pal);

 Torus.Init;
 Normals(Faces,Vertices,FNormals,VNormals,64);

 GetMem(Coords,VerticeCount*SizeOf(TCoord));
 GetMem(TempNorm,VerticeCount*SizeOf(TVector));
{$ifdef hidden}
 GetMem(TempNorm2,FaceCount*SizeOf(TVector));
{$else}
 {$ifdef fullface}
 GetMem(TempNorm2,FaceCount*SizeOf(TVector));
 {$endif}
{$endif}

{$ifdef sort}
 GetMem(FaceList,FaceCount*2);
 GetMem(DeltaZ  ,FaceCount*4);
{$endif}

 phix:=0;
 phiy:=0;
 phiz:=0;

 with Light do begin x:=1; y:=1; z:=1; end;

 time:=ticks;

 repeat

  Port[$3c4]:=2;
  Port[$3c5]:=15;
 { for i:=0 to MaxY do FillChar(Mem[$A000:Page+NextLine*i],NextLine,i); }
  asm
   mov es,SegA000
   mov di,Page
   mov dx,MaxY
   mov ax,1
  @nextline:
   mov cx,NextLine
   rep stosb
   inc ax
   dec dx
  jns @nextline
  end;

  InitZBuffers;

  BaseShade:=1;
  inittrigo(phix,phiy,phiz);
  translate(0,+20,0,@Vertices,Coords,VerticeCount);
  drawworld;

  BaseShade:=128;
  inittrigo((phix+64)and 255,phiy,phiz);
  translate(160,-20,0,@Vertices,Coords,VerticeCount);
  drawworld;

  inc(phix,1);
  inc(phiy,4);
  inc(phiz,2);

  swap;

  inc(count);

 until keypressed;

 TextMode;

 WriteLn('Frames drawn = ',Count);
 WriteLn('Frame Rate   = ',Count*18.2/(Ticks-Time):0:2,' /s');

end.